<?php

/**
 * webEdition CMS
 *
 * $Rev: 9900 $
 * $Author: mokraemer $
 * $Date: 2015-05-25 22:17:40 +0200 (Mon, 25 May 2015) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_votingSelect($attribs){
	global $DB_WE;

	if($GLOBALS['we_editmode'] && isset($GLOBALS['_we_voting']) && isset($GLOBALS['_we_voting_namespace'])){
		$submitonchange = weTag_getAttribute('submitonchange', $attribs, false, we_base_request::BOOL);
		$firstentry = weTag_getAttribute('firstentry', $attribs, '', we_base_request::RAW);
		$reload = weTag_getAttribute('reload', $attribs, $submitonchange, we_base_request::BOOL);
		$parentid = weTag_getAttribute('parentid', $attribs, 0, we_base_request::INT);

		$select_name = $GLOBALS['_we_voting_namespace'];

		$newAttribs = array(
			'name' => 'we_' . $GLOBALS['we_doc']->Name . '_txt[' . $select_name . ']'
		);

		$val = oldHtmlspecialchars($GLOBALS['we_doc']->issetElement($select_name) ? $GLOBALS['we_doc']->getElement($select_name) : 0);

		$newAttribs['onchange'] = ($submitonchange ?
				'we_submitForm();' :
				'_EditorFrame.setEditorIsHot(true)' . ($reload ? (';setScrollTo();top.we_cmd(\'reload_editpage\');') : '') );

		$options = (isset($attribs['firstentry']) ? getHtmlTag('option', array('value' => ''), $firstentry, true) : '');

		$hasOpt = false;
		if($parentid){
			$DB_WE->query('SELECT ID FROM ' . VOTING_TABLE . ' WHERE IsFolder=1 AND ParentID=' . $parentid);
			$folders = $DB_WE->getAll(true);
			$folders[] = $parentid;
		}

		$DB_WE->query('SELECT ID,Text,Path,IsFolder FROM ' . VOTING_TABLE . ' WHERE 1 ' . ($parentid ? ' AND ParentID IN(' . $folders . ')' : '') . we_voting_voting::getOwnersSql() . ' ORDER BY Path');
		while($DB_WE->next_record()){
			if($DB_WE->f('IsFolder')){
				$options.=($hasOpt ? '</optgroup>' : '') . '<optgroup label="' . $DB_WE->f('Path') . '">';
				$hasOpt = true;
				continue;
			}
			$options .= getHtmlTag('option', ($DB_WE->f('ID') == $val ? array('value' => $DB_WE->f("ID"), 'selected' => 'selected') : array('value' => $DB_WE->f('ID'))), $DB_WE->f('Text'));
		}
		return getHtmlTag('select', $newAttribs, $options . ($hasOpt ? '</optgroup>' : ''), true);
	}
}
